package java.util;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.text.DateFormat;
import java.text.SimpleDateFormat;

public class Date implements Serializable, Cloneable {
   private transient Calendar cal;
   private transient long fastTime;
   private transient boolean modified;
   private static final long serialVersionUID = 7523967970034938905L;
   private static final String[] wtb = new String[]{"am", "pm", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday", "sunday", "january", "february", "march", "april", "may", "june", "july", "august", "september", "october", "november", "december", "gmt", "ut", "utc", "est", "edt", "cst", "cdt", "mst", "mdt", "pst", "pdt"};
   private static final int[] ttb = new int[]{14, 1, 0, 0, 0, 0, 0, 0, 0, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 10000, 10000, 10000, 10300, 10240, 10360, 10300, 10420, 10360, 10480, 10420};

   public Date() {
      this(System.currentTimeMillis());
   }

   public Date(long var1) {
      this.cal = null;
      this.fastTime = var1;
      this.modified = false;
   }

   public Date(int var1, int var2, int var3) {
      this(var1, var2, var3, 0, 0, 0);
   }

   public Date(int var1, int var2, int var3, int var4, int var5) {
      this(var1, var2, var3, var4, var5, 0);
   }

   public Date(int var1, int var2, int var3, int var4, int var5, int var6) {
      this.cal = new GregorianCalendar(var1 + 1900, var2, var3, var4, var5, var6);
      this.cal.complete();
      this.modified = false;
   }

   public Date(String var1) {
      this(parse(var1));
   }

   public static long UTC(int var0, int var1, int var2, int var3, int var4, int var5) {
      GregorianCalendar var6 = new GregorianCalendar(TimeZone.getTimeZone("GMT"));
      ((Calendar)var6).set(1, var0 + 1900);
      ((Calendar)var6).set(2, var1);
      ((Calendar)var6).set(5, var2);
      ((Calendar)var6).set(11, var3);
      ((Calendar)var6).set(12, var4);
      ((Calendar)var6).set(13, var5);
      ((Calendar)var6).set(14, 0);
      return ((Calendar)var6).getTimeInMillis();
   }

   public static long parse(String var0) {
      int var1 = -1;
      byte var2 = -1;
      byte var3 = -1;
      int var4 = -1;
      byte var5 = -1;
      byte var6 = -1;
      char var7 = '\uffff';
      int var8 = 0;
      int var9 = -1;
      int var10 = -1;
      char var11 = 0;
      if (var0 != null) {
         int var12 = var0.length();

         while(true) {
            if (var8 >= var12) {
               if (var1 >= 0 && var2 >= 0 && var3 >= 0) {
                  if (var6 < 0) {
                     var6 = 0;
                  }

                  if (var5 < 0) {
                     var5 = 0;
                  }

                  if (var4 < 0) {
                     var4 = 0;
                  }

                  if (var10 == -1) {
                     return (new Date(var1, var2, var3, var4, var5, var6)).getTime();
                  }

                  return UTC(var1, var2, var3, var4, var5, var6) + (long)(var10 * '\uea60');
               }
               break;
            }

            var7 = var0.charAt(var8);
            ++var8;
            if (var7 > ' ' && var7 != ',') {
               if (var7 == '(') {
                  int var21 = 1;

                  while(var8 < var12) {
                     var7 = var0.charAt(var8);
                     ++var8;
                     if (var7 == '(') {
                        ++var21;
                     } else if (var7 == ')') {
                        --var21;
                        if (var21 <= 0) {
                           break;
                        }
                     }
                  }
               } else if (var7 >= '0' && var7 <= '9') {
                  for(var9 = var7 - 48; var8 < var12 && (var7 = var0.charAt(var8)) >= '0' && var7 <= '9'; ++var8) {
                     var9 = var9 * 10 + var7 - 48;
                  }

                  if (var11 != '+' && (var11 != '-' || var1 < 0)) {
                     if (var9 >= 70) {
                        if (var1 >= 0 || var7 > ' ' && var7 != ',' && var7 != '/' && var8 < var12) {
                           break;
                        }

                        var1 = var9 < 1900 ? var9 : var9 - 1900;
                     } else if (var7 == ':') {
                        if (var4 < 0) {
                           var4 = (byte)var9;
                        } else {
                           if (var5 >= 0) {
                              break;
                           }

                           var5 = (byte)var9;
                        }
                     } else if (var7 == '/') {
                        if (var2 < 0) {
                           var2 = (byte)(var9 - 1);
                        } else {
                           if (var3 >= 0) {
                              break;
                           }

                           var3 = (byte)var9;
                        }
                     } else {
                        if (var8 < var12 && var7 != ',' && var7 > ' ' && var7 != '-') {
                           break;
                        }

                        if (var4 >= 0 && var5 < 0) {
                           var5 = (byte)var9;
                        } else if (var5 >= 0 && var6 < 0) {
                           var6 = (byte)var9;
                        } else {
                           if (var3 >= 0) {
                              break;
                           }

                           var3 = (byte)var9;
                        }
                     }
                  } else {
                     if (var9 < 24) {
                        var9 *= 60;
                     } else {
                        var9 = var9 % 100 + var9 / 100 * 60;
                     }

                     if (var11 == '+') {
                        var9 = -var9;
                     }

                     if (var10 != 0 && var10 != -1) {
                        break;
                     }

                     var10 = var9;
                  }

                  var11 = 0;
               } else if (var7 != '/' && var7 != ':' && var7 != '+' && var7 != '-') {
                  int var13;
                  for(var13 = var8 - 1; var8 < var12; ++var8) {
                     var7 = var0.charAt(var8);
                     if ((var7 < 'A' || var7 > 'Z') && (var7 < 'a' || var7 > 'z')) {
                        break;
                     }
                  }

                  if (var8 <= var13 + 1) {
                     break;
                  }

                  int var14 = wtb.length;

                  while(true) {
                     --var14;
                     if (var14 < 0) {
                        break;
                     }

                     if (wtb[var14].regionMatches(true, 0, var0, var13, var8 - var13)) {
                        int var15 = ttb[var14];
                        if (var15 != 0) {
                           if (var15 == 1) {
                              if (var4 > 12 || var4 < 1) {
                                 throw new IllegalArgumentException();
                              }

                              if (var4 < 12) {
                                 var4 += 12;
                              }
                           } else if (var15 == 14) {
                              if (var4 > 12 || var4 < 1) {
                                 throw new IllegalArgumentException();
                              }

                              if (var4 == 12) {
                                 var4 = 0;
                              }
                           } else if (var15 <= 13) {
                              if (var2 >= 0) {
                                 throw new IllegalArgumentException();
                              }

                              var2 = (byte)(var15 - 2);
                           } else {
                              var10 = var15 - 10000;
                           }
                        }
                        break;
                     }
                  }

                  if (var14 < 0) {
                     break;
                  }

                  var11 = 0;
               } else {
                  var11 = var7;
               }
            }
         }
      }

      throw new IllegalArgumentException();
   }

   public int getYear() {
      this.checkCal();
      this.checkModified();
      return this.cal.get(1) - 1900;
   }

   public void setYear(int var1) {
      this.checkCal();
      this.cal.clear(16);
      this.cal.clear(15);
      this.cal.set(1, var1 + 1900);
      this.modified = true;
   }

   public int getMonth() {
      this.checkCal();
      this.checkModified();
      return this.cal.get(2);
   }

   public void setMonth(int var1) {
      this.checkCal();
      this.cal.clear(16);
      this.cal.clear(15);
      this.cal.set(2, var1);
      this.modified = true;
   }

   public int getDate() {
      this.checkCal();
      this.checkModified();
      return this.cal.get(5);
   }

   public void setDate(int var1) {
      this.checkCal();
      this.cal.clear(16);
      this.cal.clear(15);
      this.cal.set(5, var1);
      this.modified = true;
   }

   public int getDay() {
      this.checkCal();
      this.checkModified();
      return this.cal.get(7) - 1;
   }

   public int getHours() {
      this.checkCal();
      this.checkModified();
      return this.cal.get(11);
   }

   public void setHours(int var1) {
      this.checkCal();
      this.cal.clear(16);
      this.cal.clear(15);
      this.cal.set(11, var1);
      this.modified = true;
   }

   public int getMinutes() {
      this.checkCal();
      this.checkModified();
      return this.cal.get(12);
   }

   public void setMinutes(int var1) {
      this.checkCal();
      this.cal.clear(16);
      this.cal.clear(15);
      this.cal.set(12, var1);
      this.modified = true;
   }

   public int getSeconds() {
      this.checkCal();
      this.checkModified();
      return this.cal.get(13);
   }

   public void setSeconds(int var1) {
      this.checkCal();
      this.cal.clear(16);
      this.cal.clear(15);
      this.cal.set(13, var1);
      this.modified = true;
   }

   public long getTime() {
      if (this.cal == null) {
         return this.fastTime;
      } else {
         this.checkModified();
         return this.cal.getTimeInMillis();
      }
   }

   public void setTime(long var1) {
      if (this.cal == null) {
         this.fastTime = var1;
         this.modified = false;
      } else {
         this.cal.setTimeInMillis(var1);
         this.cal.computeFields();
         this.modified = false;
      }
   }

   public boolean before(Date var1) {
      return this.getTime() < var1.getTime();
   }

   public boolean after(Date var1) {
      return this.getTime() > var1.getTime();
   }

   public boolean equals(Object var1) {
      return var1 != null && var1 instanceof Date && this.getTime() == ((Date)var1).getTime();
   }

   public int hashCode() {
      long var1 = this.getTime();
      return (int)var1 ^ (int)(var1 >> 32);
   }

   public String toString() {
      SimpleDateFormat var1 = new SimpleDateFormat("EEE MMM dd HH:mm:ss zzz yyyy", Locale.US);
      ((DateFormat)var1).setTimeZone(TimeZone.getDefault());
      return ((DateFormat)var1).format(this);
   }

   public String toLocaleString() {
      DateFormat var1 = DateFormat.getDateTimeInstance();
      var1.setTimeZone(TimeZone.getDefault());
      return var1.format(this);
   }

   public String toGMTString() {
      SimpleDateFormat var1 = new SimpleDateFormat("d MMM yyyy HH:mm:ss 'GMT'", Locale.US);
      ((DateFormat)var1).setTimeZone(TimeZone.getTimeZone("GMT"));
      return ((DateFormat)var1).format(this);
   }

   public int getTimezoneOffset() {
      this.checkCal();
      this.checkModified();
      TimeZone var1 = this.cal.getTimeZone();
      int var2 = var1.getOffset(this.cal.get(0), this.cal.get(1), this.cal.get(2), this.cal.get(5), this.cal.get(7), this.cal.get(11) * this.cal.get(12) * this.cal.get(13) * 1000);
      return -(var2 / 1000 / 60);
   }

   private void writeObject(ObjectOutputStream var1) throws IOException {
      var1.writeLong(this.getTime());
   }

   private void readObject(ObjectInputStream var1) throws IOException, ClassNotFoundException {
      long var2 = var1.readLong();
      this.cal = new GregorianCalendar(TimeZone.getDefault());
      this.cal.setTimeInMillis(var2);
      this.cal.computeFields();
      this.modified = false;
   }

   private void checkCal() {
      if (this.cal == null) {
         this.cal = new GregorianCalendar(TimeZone.getDefault());
         this.cal.setTimeInMillis(this.fastTime);
         this.cal.computeFields();
         this.modified = false;
      }

   }

   private void checkModified() {
      if (this.modified) {
         this.cal.complete();
         this.modified = false;
      }

   }
}
