package java.util;

public abstract class ListResourceBundle extends ResourceBundle {
   private Hashtable lookup;

   public final Object handleGetObject(String var1) {
      if (this.lookup == null) {
         this.loadLookup();
      }

      return this.lookup.get(var1);
   }

   public Enumeration getKeys() {
      if (this.lookup == null) {
         this.loadLookup();
      }

      Object var1 = null;
      Enumeration var5;
      if (super.parent != null) {
         Hashtable var2 = new Hashtable();
         Enumeration var3 = super.parent.getKeys();

         while(var3.hasMoreElements()) {
            var2.put(var3.nextElement(), this);
         }

         Enumeration var4 = this.lookup.keys();

         while(var4.hasMoreElements()) {
            var2.put(var4.nextElement(), this);
         }

         var5 = var2.keys();
      } else {
         var5 = this.lookup.keys();
      }

      return var5;
   }

   protected abstract Object[][] getContents();

   private void loadLookup() {
      Object[][] var1 = this.getContents();
      this.lookup = new Hashtable(var1.length);

      for(int var2 = 0; var2 < var1.length; ++var2) {
         this.lookup.put(var1[var2][0], var1[var2][1]);
      }

   }
}
