package java.util;

public class StringTokenizer implements Enumeration {
   private int currentPosition;
   private int maxPosition;
   private String str;
   private String delimiters;
   private boolean retTokens;

   public StringTokenizer(String var1, String var2, boolean var3) {
      this.currentPosition = 0;
      this.str = var1;
      this.maxPosition = var1.length();
      this.delimiters = var2;
      this.retTokens = var3;
   }

   public StringTokenizer(String var1, String var2) {
      this(var1, var2, false);
   }

   public StringTokenizer(String var1) {
      this(var1, " \t\n\r", false);
   }

   private void skipDelimiters() {
      while(!this.retTokens && this.currentPosition < this.maxPosition && this.delimiters.indexOf(this.str.charAt(this.currentPosition)) >= 0) {
         ++this.currentPosition;
      }

   }

   public boolean hasMoreTokens() {
      this.skipDelimiters();
      return this.currentPosition < this.maxPosition;
   }

   public String nextToken() {
      this.skipDelimiters();
      if (this.currentPosition >= this.maxPosition) {
         throw new NoSuchElementException();
      } else {
         int var1;
         for(var1 = this.currentPosition; this.currentPosition < this.maxPosition && this.delimiters.indexOf(this.str.charAt(this.currentPosition)) < 0; ++this.currentPosition) {
         }

         if (this.retTokens && var1 == this.currentPosition && this.delimiters.indexOf(this.str.charAt(this.currentPosition)) >= 0) {
            ++this.currentPosition;
         }

         return this.str.substring(var1, this.currentPosition);
      }
   }

   public String nextToken(String var1) {
      this.delimiters = var1;
      return this.nextToken();
   }

   public boolean hasMoreElements() {
      return this.hasMoreTokens();
   }

   public Object nextElement() {
      return this.nextToken();
   }

   public int countTokens() {
      int var1 = 0;

      for(int var2 = this.currentPosition; var2 < this.maxPosition; ++var1) {
         while(!this.retTokens && var2 < this.maxPosition && this.delimiters.indexOf(this.str.charAt(var2)) >= 0) {
            ++var2;
         }

         if (var2 >= this.maxPosition) {
            break;
         }

         int var3;
         for(var3 = var2; var2 < this.maxPosition && this.delimiters.indexOf(this.str.charAt(var2)) < 0; ++var2) {
         }

         if (this.retTokens && var3 == var2 && this.delimiters.indexOf(this.str.charAt(var2)) >= 0) {
            ++var2;
         }
      }

      return var1;
   }
}
