package java.util;

import java.io.Serializable;

public abstract class TimeZone implements Serializable, Cloneable {
   // $FF: renamed from: ID java.lang.String
   private String field_0;
   private static TimeZone defaultZone = null;
   private static final int millisPerHour = 3600000;
   private static final SimpleTimeZone[] timeZoneData = new SimpleTimeZone[]{new SimpleTimeZone(0, "GMT"), new SimpleTimeZone(3600000, "ECT", 2, -1, 1, 7200000, 9, -1, 1, 7200000), new SimpleTimeZone(7200000, "EET", 2, -1, 1, 0, 9, -1, 1, 0), new SimpleTimeZone(7200000, "ART", 3, -1, 6, 0, 8, -1, 6, 0), new SimpleTimeZone(10800000, "EAT"), new SimpleTimeZone(Integer.MIN_VALUE, "MET"), new SimpleTimeZone(14400000, "NET"), new SimpleTimeZone(18000000, "PLT"), new SimpleTimeZone(Integer.MIN_VALUE, "IST"), new SimpleTimeZone(21600000, "BST"), new SimpleTimeZone(25200000, "VST"), new SimpleTimeZone(28800000, "CTT"), new SimpleTimeZone(32400000, "JST"), new SimpleTimeZone(Integer.MIN_VALUE, "ACT", 9, -1, 1, 7200000, 2, -1, 1, 10800000), new SimpleTimeZone(36000000, "AET", 9, -1, 1, 7200000, 2, -1, 1, 10800000), new SimpleTimeZone(39600000, "SST"), new SimpleTimeZone(43200000, "NST", 9, 1, 1, 7200000, 2, 3, 1, 10800000), new SimpleTimeZone(-39600000, "MIT"), new SimpleTimeZone(-36000000, "HST"), new SimpleTimeZone(-32400000, "AST", 3, 1, 1, 7200000, 9, -1, 1, 7200000), new SimpleTimeZone(-28800000, "PST", 3, 1, 1, 7200000, 9, -1, 1, 7200000), new SimpleTimeZone(-25200000, "PNT"), new SimpleTimeZone(-25200000, "MST", 3, 1, 1, 7200000, 9, -1, 1, 7200000), new SimpleTimeZone(-21600000, "CST", 3, 1, 1, 7200000, 9, -1, 1, 7200000), new SimpleTimeZone(-18000000, "EST", 3, 1, 1, 7200000, 9, -1, 1, 7200000), new SimpleTimeZone(-18000000, "IET"), new SimpleTimeZone(-14400000, "PRT"), new SimpleTimeZone(Integer.MIN_VALUE, "CNT", 3, 1, 1, 7200000, 9, -1, 1, 7200000), new SimpleTimeZone(-10800000, "AGT"), new SimpleTimeZone(-10800000, "BET", 9, 1, 1, 0, 1, 3, 1, 0), new SimpleTimeZone(-3600000, "CAT")};
   private static Hashtable lookup;

   public abstract int getOffset(int var1, int var2, int var3, int var4, int var5, int var6);

   public abstract void setRawOffset(int var1);

   public abstract int getRawOffset();

   public String getID() {
      return this.field_0;
   }

   public void setID(String var1) {
      this.field_0 = var1;
   }

   public abstract boolean useDaylightTime();

   public abstract boolean inDaylightTime(Date var1);

   public static synchronized TimeZone getTimeZone(String var0) {
      try {
         return (SimpleTimeZone)lookup.get(var0);
      } catch (MissingResourceException var1) {
         return (SimpleTimeZone)lookup.get("GMT");
      }
   }

   public static synchronized String[] getAvailableIDs(int var0) {
      String[] var1 = new String[10];
      int var2 = 0;

      for(int var3 = 0; var3 < timeZoneData.length; ++var3) {
         if (var0 == timeZoneData[var3].getRawOffset()) {
            var1[var2++] = timeZoneData[var3].getID();
         }
      }

      String[] var4 = new String[var2];
      System.arraycopy(var1, 0, var4, 0, var2);
      return var4;
   }

   public static synchronized String[] getAvailableIDs() {
      String[] var0 = new String[40];
      int var1 = 0;

      for(int var2 = 0; var2 < timeZoneData.length; ++var2) {
         var0[var1++] = timeZoneData[var2].getID();
      }

      String[] var3 = new String[var1];
      System.arraycopy(var0, 0, var3, 0, var1);
      return var3;
   }

   public static synchronized TimeZone getDefault() {
      if (defaultZone == null) {
         String var0 = System.getProperty("user.timezone", "GMT");
         if (var0 != null) {
            defaultZone = getTimeZone(var0);
            if (defaultZone != null) {
               return defaultZone;
            }
         }

         return getTimeZone("GMT");
      } else {
         return defaultZone;
      }
   }

   public static synchronized void setDefault(TimeZone var0) {
      defaultZone = var0;
   }

   public Object clone() {
      try {
         TimeZone var1 = (TimeZone)super.clone();
         var1.field_0 = this.field_0;
         return var1;
      } catch (CloneNotSupportedException var2) {
         throw new InternalError();
      }
   }

   static {
      lookup = new Hashtable(timeZoneData.length);

      for(int var0 = 0; var0 < timeZoneData.length; ++var0) {
         lookup.put(timeZoneData[var0].getID(), timeZoneData[var0]);
      }

   }
}
